1 #!/bin/sh -- # no runable script, just for vi
3 # we all like colorful messages
4 CERROR
="\e[1;31m" # red
5 CWARNING
="\e[1;33m" # yellow
6 CMSG
="\e[1;32m" # green
7 CINFO
="\e[1;96m" # light blue
8 CDEBUG
="\e[1;94m" # blue
9 CNORMAL
="\e[0;39m" # default system console color
10 CDONE
="\e[1;32m" # green
11 CPASS
="\e[1;32m" # green
12 CFAIL
="\e[1;31m" # red
13 CCMD
="\e[1;35m" # pink
15 msgdie
() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16 msgwarn
() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17 msgmsg
() { echo "${CMSG}$1${CNORMAL}" >&2; }
18 msginfo
() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19 msgdebug
() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20 msgdone
() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21 msgnwarn
() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgnmsg
() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23 msgninfo
() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgndebug
() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgtest
() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26 msgpass
() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27 msgskip
() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28 msgfail
() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
30 # enable / disable Debugging
31 MSGLEVEL
=${MSGLEVEL:-3}
32 if [ $MSGLEVEL -le 0 ]; then
35 if [ $MSGLEVEL -le 1 ]; then
39 if [ $MSGLEVEL -le 2 ]; then
43 if [ $MSGLEVEL -le 3 ]; then
47 if [ $MSGLEVEL -le 4 ]; then
52 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
53 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
54 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
55 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
56 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
59 echo "${CDONE}DONE${CNORMAL}" >&2;
64 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
65 if [ -f .
/aptconfig.conf
]; then
66 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
67 elif [ -f ..
/aptconfig.conf
]; then
68 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
70 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
73 aptconfig
() { runapt apt
-config $
*; }
74 aptcache
() { runapt apt
-cache $
*; }
75 aptget
() { runapt apt
-get $
*; }
76 aptftparchive
() { runapt apt
-ftparchive $
*; }
77 aptkey
() { runapt apt
-key $
*; }
79 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir
--force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log $
*
83 TMPWORKINGDIRECTORY
=$(mktemp -d)
84 local TESTDIR
=$(readlink -f $(dirname $0))
85 msgninfo
"Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
86 BUILDDIRECTORY
="${TESTDIR}/../../build/bin"
87 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
88 local OLDWORKINGDIRECTORY
=$(pwd)
89 CURRENTTRAP
="cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY"
90 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
91 cd $TMPWORKINGDIRECTORY
92 mkdir rootdir aptarchive keys
94 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d
95 mkdir -p var
/cache var
/lib var
/log
96 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
97 local STATUSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
98 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
99 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
101 touch var/lib/dpkg/status
103 touch var/lib/dpkg/available
105 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
107 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
108 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
109 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive
/Packages
111 touch aptarchive
/Packages
113 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys
/
114 ln -s ${TMPWORKINGDIRECTORY}/keys
/joesixpack.pub rootdir
/etc
/apt
/trusted.gpg.d
/joesixpack.gpg
115 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
116 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
117 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
118 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
119 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
120 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
121 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
122 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
123 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
124 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
129 configarchitecture
() {
130 local CONFFILE
=rootdir
/etc
/apt
/apt.conf.d
/01multiarch.conf
131 echo "APT::Architecture \"$1\";" > $CONFFILE
133 while [ -n "$1" ]; do
134 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
139 setupsimplenativepackage
() {
143 local RELEASE
="${4:-unstable}"
144 local DEPENDENCIES
="$5"
145 local DESCRIPTION
="$6"
146 local SECTION
="${7:-others}"
148 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
151 DISTSECTION
="$(echo "$SECTION" | cut -d'/' -f 1)"
153 local BUILDDIR
=incoming
/${NAME}-${VERSION}
154 mkdir -p ${BUILDDIR}/debian
/source
156 echo "* most suckless software product ever" > FEATURES
157 test -e debian
/copyright
|| echo "Copyleft by Joe Sixpack $(date +%Y)" > debian
/copyright
158 test -e debian
/changelog
|| echo "$NAME ($VERSION) $RELEASE; urgency=low
162 -- Joe Sixpack <joe@example.org> $(date -R)" > debian
/changelog
163 test -e debian
/control
|| echo "Source: $NAME
166 Maintainer: Joe Sixpack <joe@example.org>
167 Build-Depends: debhelper (>= 7)
168 Standards-Version: 3.9.1
171 Architecture: $ARCH" > debian
/control
172 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian
/control
173 if [ -z "$DESCRIPTION" ]; then
174 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
175 If you find such a package installed on your system,
176 YOU did something horribly wrong! They are autogenerated
177 und used only by testcases for APT and surf no other propose…" >> debian
/control
179 echo "Description: $DESCRIPTION" >> debian
/control
181 test -e debian
/compat
|| echo "7" > debian
/compat
182 test -e debian
/source
/format
|| echo "3.0 (native)" > debian
/source
/format
183 test -e debian
/rules
|| cp /usr
/share
/doc
/debhelper
/examples
/rules.tiny debian
/rules
187 buildsimplenativepackage
() {
191 local RELEASE
="${4:-unstable}"
192 local DEPENDENCIES
="$5"
193 local DESCRIPTION
="$6"
194 local SECTION
="${7:-others}"
196 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
199 DISTSECTION
="$(echo "$SECTION" | cut -d'/' -f 1)"
201 setupsimplenativepackage
"$NAME" "$ARCH" "$VERSION" "$RELEASE" "$DEPENDENCIES" "$DESCRIPTION" "$SECTION"
202 buildpackage
"incoming/${NAME}-${VERSION}" "$RELEASE" "$DISTSECTION"
203 rm -rf "incoming/${NAME}-${VERSION}"
210 msgninfo
"Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
212 if [ "$ARCH" = "all" ]; then
213 ARCH
="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
215 local BUILT
="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
216 local PKGS
="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
217 local SRCS
="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
220 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.pkglist
223 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.srclist
229 if [ -d incoming
]; then
230 buildaptarchivefromincoming $
*
232 buildaptarchivefromfiles $
*
236 createaptftparchiveconfig
() {
237 local ARCHS
="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
238 if [ -z "$ARCHS" ]; then
239 # the pool is empty, so we will operate on faked packages - let us use the configured archs
240 ARCHS
="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
243 ArchiveDir "' >> ftparchive.conf
244 echo -n $(readlink -f .) >> ftparchive.conf
246 CacheDir "' >> ftparchive.conf
247 echo -n $(readlink -f ..) >> ftparchive.conf
249 FileListDir "' >> ftparchive.conf
250 echo -n $(readlink -f pool/) >> ftparchive.conf
254 Packages::Compress ". gzip bzip2 lzma";
255 Sources::Compress ". gzip bzip2 lzma";
256 Contents::Compress ". gzip bzip2 lzma";
260 SrcDirectory "pool/";
266 Label "apttestcases";
268 Description "repository with dummy packages";
269 Architectures "' >> ftparchive.conf
270 echo -n "$ARCHS" >> ftparchive.conf
274 };' >> ftparchive.conf
275 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
276 echo -n 'tree "dists/' >> ftparchive.conf
277 echo -n "$DIST" >> ftparchive.conf
279 Architectures "' >> ftparchive.conf
280 echo -n "$ARCHS" >> ftparchive.conf
282 FileList "' >> ftparchive.conf
283 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
285 SourceFileList "' >> ftparchive.conf
286 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
288 Sections "' >> ftparchive.conf
289 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
291 };' >> ftparchive.conf
295 buildaptftparchivedirectorystructure
() {
296 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
297 for DIST
in $DISTS; do
298 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
299 for SECTION
in $SECTIONS; do
300 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
301 for ARCH
in $ARCHS; do
302 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
304 mkdir -p dists
/${DIST}/${SECTION}/source
305 mkdir -p dists
/${DIST}/${SECTION}/i18n
310 buildaptarchivefromincoming
() {
311 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
313 [ -e pool
] || ln -s ..
/incoming pool
314 [ -e ftparchive.conf
] || createaptftparchiveconfig
315 [ -e dists
] || buildaptftparchivedirectorystructure
316 msgninfo
"\tGenerate Packages, Sources and Contents files… "
317 aptftparchive
-qq generate ftparchive.conf
319 msgninfo
"\tGenerate Release files… "
320 for dir
in $(find ./dists -mindepth 1 -maxdepth 1 -type d); do
321 aptftparchive
-qq release
$dir -o APT
::FTPArchive
::Release
::Codename
="$(echo "$dir" | cut -d'/' -f 3)" | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
327 buildaptarchivefromfiles
() {
328 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
330 if [ -f Packages
]; then
331 msgninfo
"\tPackages file… "
332 cat Packages
| gzip > Packages.gz
333 cat Packages
| bzip2 > Packages.bz2
334 cat Packages
| lzma
> Packages.lzma
337 if [ -f Sources
]; then
338 msgninfo
"\tSources file… "
339 cat Sources
| gzip > Sources.gz
340 cat Sources
| bzip2 > Sources.bz2
341 cat Sources
| lzma
> Sources.lzma
344 msgninfo
"\tRelease file… "
345 aptftparchive
-qq release .
| sed -e '/0 Release$/ d' > Release
# remove the self reference
350 setupdistsaptarchive
() {
351 local APTARCHIVE
=$(readlink -f ./aptarchive)
352 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
353 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
354 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
355 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
356 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
357 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
358 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
363 setupflataptarchive
() {
364 local APTARCHIVE
=$(readlink -f ./aptarchive)
365 if [ -f ${APTARCHIVE}/Packages
]; then
366 msgninfo
"\tadd deb sources.list line… "
367 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
370 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
372 if [ -f ${APTARCHIVE}/Sources
]; then
373 msgninfo
"\tadd deb-src sources.list line… "
374 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
377 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
383 if [ -e aptarchive
/dists
]; then
389 msgninfo
"\tSync APT's cache with the archive… "
395 local SIGNER
="${1:-Joe Sixpack}"
396 msgninfo
"\tSign archive with $SIGNER key… "
398 for KEY
in $(find keys/ -name '*.sec'); do
399 SECKEYS
="$SECKEYS --secret-keyring $KEY"
402 for KEY
in $(find keys/ -name '*.pub'); do
403 PUBKEYS
="$PUBKEYS --keyring $KEY"
405 for RELEASE
in $(find aptarchive/ -name Release); do
406 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg
${RELEASE}
411 changetowebserver
() {
412 if which weborf
> /dev
/null
; then
413 weborf
-xb aptarchive
/ 2>&1 > /dev
/null
&
414 CURRENTTRAP
="kill $(ps | grep weborf | sed -e 's#^[ ]*##' | cut -d' ' -f 1); $CURRENTTRAP"
415 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
416 local APTARCHIVE
="file://$(readlink -f ./aptarchive)"
417 for LIST
in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
418 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
426 local DIFFTEXT
="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
427 if [ -n "$DIFFTEXT" ]; then
439 msgtest
"Test for correctness of file" "$FILE"
441 echo -n "" | checkdiff
$FILE - && msgpass
|| msgfail
443 echo "$*" | checkdiff
$FILE - && msgpass
|| msgfail
448 local COMPAREFILE
=$(mktemp)
449 echo "$1" > $COMPAREFILE
451 msgtest
"Test for equality of" "$*"
452 $
* 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
457 local COMPAREFILE1
=$(mktemp)
458 local COMPAREFILE2
=$(mktemp)
459 local COMPAREAGAINST
=$(mktemp)
460 echo "$1" > $COMPAREFILE1
461 echo "$2" > $COMPAREFILE2
463 msgtest
"Test for equality OR of" "$*"
464 $
* 2>&1 1> $COMPAREAGAINST
465 (checkdiff
$COMPAREFILE1 $COMPAREAGAINST 1> /dev
/null
||
466 checkdiff
$COMPAREFILE2 $COMPAREAGAINST 1> /dev
/null
) && msgpass
||
467 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
468 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
470 rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST
474 local VIRTUAL
="N: Can't select versions from package '$1' as it purely virtual"
477 while [ -n "$1" ]; do
479 N: Can't select versions from package '$1' as it purely virtual"
480 PACKAGE
="${PACKAGE} $1"
483 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
485 N: No packages found"
486 local COMPAREFILE
=$(mktemp)
487 local ARCH
=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
488 eval `apt-config shell ARCH APT::Architecture`
489 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
490 aptcache show
-q=0 $PACKAGE 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
495 msgtest
"Test for non-existent packages" "apt-cache show $*"
496 local SHOWPKG
="$(aptcache show $* 2>&1 | grep '^Package: ')"
497 if [ -n "$SHOWPKG" ]; then
506 testdpkginstalled
() {
507 msgtest
"Test for correctly installed package(s) with" "dpkg -l $*"
508 local PKGS
="$(dpkg -l $* | grep '^[a-z]' | grep '^[^i]' | wc -l)"
509 if [ "$PKGS" != 0 ]; then
511 dpkg
-l $
* | grep '^[a-z]'
518 testdpkgnoninstalled
() {
519 msgtest
"Test for correctly non-installed package(s) with" "dpkg -l $*"
520 local PKGS
="$(dpkg -l $* | grep '^[a-z]' | grep '^[^u]' | wc -l)"
521 if [ "$PKGS" != 0 ]; then
523 dpkg
-l $
* | grep '^[a-z]'